@page roadmap Roadmap
@parent about 3

@description Learn about CanJS’s future plans, how we make them, and how you can influence them.

@body

## How our roadmap is decided

CanJS’s direction is shaped by its community creating [guides/contributing/feature-suggestion feature suggestions] and [guides/contributing/bug-report bug reports],
and giving them a `+1`.

Then, the [DoneJS core team members](https://donejs.com/About.html#team) prioritize
issues with a `P0` to `P4` tag indicating their priority:

- `P0` - An issue that will preempt any other issues currently being worked on.
- `P1` - A critical feature or bug that needs to be fixed to keep CanJS’s high degree of quality.
- `P2` - A feature or bug that is less likely to be encountered, but something we intend to get to.
- `P3` - A nice to have. The OS team might get to it, but it’s helpful if the community assists.
- `P4` - A nice to have that the OS team will accept, but will be unlikely to prioritize any effort towards.




## Current Roadmap

CanJS’s roadmap is constantly changing, so showing a schedule would be impossible.
The following links to CanJS’s feature issues grouped by priorities:

 - [P1 ](https://github.com/search?q=org%3Acanjs+label%3Aenhancement+label%3AP1&ref=searchresults&state=open&type=Issues)
 - [P2 ](https://github.com/search?q=org%3Acanjs+label%3Aenhancement+label%3AP2&ref=searchresults&state=open&type=Issues)
 - [P3 ](https://github.com/search?q=org%3Acanjs+label%3Aenhancement+label%3AP3&ref=searchresults&state=open&type=Issues)


## How to influence the roadmap


These priorities can change.  The best ways to influence the priority of an issue is to:

 - Add test or implement the feature or fix
 - Come to a contributors meeting and let us know why it’s important to you
 - Make your case clearly and concisely in the issue
 - `+1` the issue to show your support
